unit uFrmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, uFrmBase, Vcl.StdCtrls, uWorkThread, uElegantThread;

type
  // ΪƵ벹дѲͬ˵Ĺһ
  TFrmMain = class(TFrmBase)

    btnStartThread: TButton;
    btnStopThread: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnStartThreadClick(Sender: TObject);

  private
    { Private declarations }

    FDataThread: TElegantThread;
    // ʾص: ݵĲȫ߳ȥݿ

    FNums: Array [0 .. 19] of integer;
    FWorkThreads: Array [0 .. 4] of TWorkThread;

    FCurNumIndex: integer;
    FTaskCount: integer; // жټˡ

    procedure OnWorkStatus(Sender: TWorkThread; AStatus: TWorkStatus);
    procedure DoOnNeedANum(Sender: TWorkThread);
    procedure DoOnCountOver(Sender: TWorkThread);
    procedure DoOnStop(Sender: TWorkThread);
  private
    procedure LockTaskCount;
    procedure UnlockTaskCount;

  public
    { Public declarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}
{ TFrmMain }

procedure TFrmMain.btnStartThreadClick(Sender: TObject);
var
  i: integer;
begin
  inherited;

  FCurNumIndex := 0;
  FTaskCount := 0;
  btnStartThread.Enabled := false;

  for i := 0 to 4 do
  begin
    FWorkThreads[i].StartThread;
  end;

end;

procedure TFrmMain.DoOnCountOver(Sender: TWorkThread);
begin
  LockTaskCount;
  try

    inc(FTaskCount);

    if FTaskCount >= 10 then
    begin
      TThread.Synchronize(nil,
        procedure
        begin
          btnStartThread.Enabled := true;
        end);
    end;

  finally
    UnlockTaskCount;
  end;
end;

procedure TFrmMain.DoOnNeedANum(Sender: TWorkThread);
begin
  // ȡ Num ݵȫ FDataThread ߳
  FDataThread.Synchronize(
    procedure
    begin
      if FCurNumIndex <= 9 then
      begin
        Sender.Num := FNums[FCurNumIndex];
        inc(FCurNumIndex);
      end;
    end);
end;

procedure TFrmMain.DoOnStop(Sender: TWorkThread);
begin
end;

procedure TFrmMain.FormCreate(Sender: TObject);
var
  i: integer;
begin
  inherited;

  FDataThread := TElegantThread.Create;

  for i := 0 to 19 do
  begin
    FNums[i] := i + 100; // ʼ Nums 
  end;

  for i := 0 to 4 do
  begin
    FWorkThreads[i] := TWorkThread.Create;
    FWorkThreads[i].OnWorkStatus := self.OnWorkStatus;
    FWorkThreads[i].OnStatusMsg := self.OnThreadDispMsg;
  end;

end;

procedure TFrmMain.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  inherited;

  for i := 0 to 4 do
  begin
    FWorkThreads[i].StopThread;
    sleep(5);
    FWorkThreads[i].Free;
  end;

  FDataThread.Free;
end;

procedure TFrmMain.LockTaskCount;
begin
  System.TMonitor.Enter(self);
end;

procedure TFrmMain.OnWorkStatus(Sender: TWorkThread; AStatus: TWorkStatus);
begin

  case AStatus of
    wsNeedANum: DoOnNeedANum(Sender);
    wsCountOver: DoOnCountOver(Sender);
    wsStop: DoOnStop(Sender);
  end;

end;

procedure TFrmMain.UnlockTaskCount;
begin
  System.TMonitor.Exit(self);
end;

end.
