unit uSimpleThread;

interface

uses
  System.Classes, System.SysUtils, System.SyncObjs;

type

  // ʾϢ,÷ DoOnStatusMsg(AMsg);
  TOnStatusMsg = procedure(AMsg: string) of object;

  // ʾϢ,һʾϢ,÷ DoOnDebugMsg(AMsg);
  TOnDebugMsg = TOnStatusMsg;

  TSimpleThread = class(TThread)
  public type // "ִй"

    TGeneralProc = procedure; // ͨ, procedure DoSomeThing;
    TObjectProc = procedure of object; // , TXxxx.DoSomeThign; õö
    TAnonymousProc = reference to procedure; // 

  private type
    TProcKind = (pkGeneral, pkObject, pkAnonymous); // "ִй"
  private

    FGeneralProc: TGeneralProc;
    FObjProc: TObjectProc;
    FAnoProc: TAnonymousProc;

    FProcKind: TProcKind;

    FEvent: TEvent; // һź
    FActiveX: boolean; // Ƿ֧߳ Com ,Ҫ߳з IE Ļ趨Ϊ True

    FOnStatusMsg: TOnStatusMsg;
    FOnDebugMsg: TOnDebugMsg;

    FTagID: integer; // ߳һ,̳߳صʱ
    FParam: integer; // ߳һʶ

    procedure SelfStart; // ߳

    procedure DoExecute; // еĴǡ߳̿ռ䡱
    procedure DoOnException(e: exception); // 쳣Ϣʾ  DoOnDebugMsg(AMsg);

    procedure SetTagID(const Value: integer);
    procedure SetParam(const Value: integer);

    procedure SetOnStatusMsg(const Value: TOnStatusMsg);
    procedure SetOnDebugMsg(const Value: TOnDebugMsg);

  protected

    FWaitStop: boolean; // ־ڼ̳ʹȷ߳Ƿֹͣ

    procedure DoOnStatusMsg(AMsg: string); // ʾͨϢ
    procedure DoOnDebugMsg(AMsg: string); // ʾʽϢ

    procedure Execute; override; //  TThread.Execute

    procedure OnThreadProcErr(e: exception); virtual; // 쳣¼

    procedure WaitThreadStop; // ȴ߳̽

    procedure BeforeExecute; virtual; // ,
    Procedure AfterExecute; virtual; // ,

    procedure SleepExceptStopped(ATimeOut: Cardinal); // ߴˣҪһ¡
    { ʱ߳ûʱͻϢһǣϢʱ򣬿ܻյ˳̵ָ߳
      ˺ϢʱҲһָֹͣ
    }

  public

    // ıһ Create Ĳ,AllowedActiveXǷ̴߳ Com
    constructor Create(AllowedActiveX: boolean = false); reintroduce;

    destructor Destroy; override;

    procedure ExeProcInThread(AProc: TGeneralProc); overload; // ,Ľӿڡ
    procedure ExeProcInThread(AProc: TObjectProc); overload;
    procedure ExeProcInThread(AProc: TAnonymousProc); overload;

    procedure StartThread; virtual;
    { ̣߳һֻһΡ
      Ժ̵߳Ӧ¼ִ
    }

    procedure StopThread; virtual; // ֹͣ߳

    property OnStatusMsg: TOnStatusMsg read FOnStatusMsg write SetOnStatusMsg;
    property OnDebugMsg: TOnDebugMsg read FOnDebugMsg write SetOnDebugMsg;
    property WaitStop: boolean read FWaitStop;
    property TagID: integer read FTagID write SetTagID;
    property Param: integer read FParam write SetParam;

  end;

implementation

uses
  ActiveX;

procedure TSimpleThread.AfterExecute;
begin
end;

procedure TSimpleThread.BeforeExecute;
begin
end;

constructor TSimpleThread.Create(AllowedActiveX: boolean);
var
  BGUID: TGUID;
begin
  inherited Create(false);
  FActiveX := AllowedActiveX;
  FreeOnTerminate := false; // ҪֶFree߳
  CreateGUID(BGUID);
  FEvent := TEvent.Create(nil, true, false, GUIDToString(BGUID));
end;

destructor TSimpleThread.Destroy;
begin
  StopThread; // ֹͣ
  WaitThreadStop; // ٵȴֹ߳ͣ
  {
    ڼ̳ Destroy УҲҪд. :
    ʱδҵõİ취ʡ
    destructor TXXThread.Destroy;
    begin
    StopThread;
    WaitThreadStop;
    xxx.Free;
    Inherited;
    end;
  }
  FEvent.Free;
  inherited;
end;

procedure TSimpleThread.DoExecute; // ˺ִеĴ,ڶ߳̿ռ
begin
  BeforeExecute;
  repeat

    FEvent.WaitFor;
    FEvent.ResetEvent; // ´waitfor һֱ
    { ﳢ˺ܶЩ SelfStart гͻ޸Ĳʹ֤
      ûбҪ,Ϊֻ startThread һΣʣµĽ߳ӰӦ¼
    }

    if not Terminated then // ߳Ҫ˳
    begin

      try

        case FProcKind of
          pkGeneral: FGeneralProc;
          pkObject: FObjProc;
          pkAnonymous: FAnoProc;
        end;

      except

        on e: exception do
        begin
          DoOnException(e);
        end;

      end;

    end;

  until Terminated;
  AfterExecute;
  // еͱʾ̲߳ˡҲزȥˣͷԴˡ

end;

procedure TSimpleThread.DoOnDebugMsg(AMsg: string);
begin
  if Assigned(FOnDebugMsg) then
    FOnDebugMsg(AMsg);
end;

procedure TSimpleThread.DoOnException(e: exception);
var
  sErrMsg: string;
begin
  sErrMsg := 'ClassName:' + ClassName + #13#10;
  sErrMsg := sErrMsg + 'TagID:' + IntToStr(FTagID) + #13#10;
  sErrMsg := sErrMsg + 'Param:' + IntToStr(Param) + #13#10;
  sErrMsg := sErrMsg + 'ErrMsg:' + e.Message + #13#10;
  DoOnDebugMsg(sErrMsg);
  OnThreadProcErr(e);
end;

procedure TSimpleThread.DoOnStatusMsg(AMsg: string);
begin
  if Assigned(FOnStatusMsg) then
    FOnStatusMsg(AMsg);
end;

procedure TSimpleThread.Execute;
begin
  // Ƿ֧ Com
  if FActiveX then
  begin
    CoInitialize(nil);
    try
      DoExecute;
    finally
      CoUninitialize;
    end;
  end
  else
    DoExecute;
end;

procedure TSimpleThread.ExeProcInThread(AProc: TGeneralProc);
begin
  FGeneralProc := AProc;
  FProcKind := pkGeneral;
  SelfStart;
end;

procedure TSimpleThread.ExeProcInThread(AProc: TObjectProc);
begin
  FObjProc := AProc;
  FProcKind := pkObject;
  SelfStart;
end;

procedure TSimpleThread.ExeProcInThread(AProc: TAnonymousProc);
begin
  FAnoProc := AProc;
  FProcKind := pkAnonymous;
  SelfStart;
end;

procedure TSimpleThread.OnThreadProcErr(e: exception);
begin;
end;

procedure TSimpleThread.SelfStart;
begin
  // γԣдû
  if FEvent.WaitFor(0) <> wrSignaled then
    FEvent.SetEvent; // waitfor ٵ,Ϣ
end;

procedure TSimpleThread.StopThread;
begin
  // ̳ĴУҪ FWaitStop ߳̽
  FWaitStop := true;
end;

procedure TSimpleThread.SetOnDebugMsg(const Value: TOnDebugMsg);
begin
  FOnDebugMsg := Value;
end;

procedure TSimpleThread.SetOnStatusMsg(const Value: TOnStatusMsg);
begin
  FOnStatusMsg := Value;
end;

procedure TSimpleThread.SetParam(const Value: integer);
begin
  FParam := Value;
end;

procedure TSimpleThread.SetTagID(const Value: integer);
begin
  FTagID := Value;
end;

procedure TSimpleThread.SleepExceptStopped(ATimeOut: Cardinal);
var
  BOldTime: Cardinal;
begin
  // sleep ʱ˳ָ,ȷ߳˳˳
  // ߳ͬʱҪ֤ȷ˳ȷʵ
  BOldTime := GetTickCount;
  while not WaitStop do
  begin
    sleep(50);
    if (GetTickCount - BOldTime) > ATimeOut then
      break;
  end;
end;

procedure TSimpleThread.StartThread;
begin
  FWaitStop := false;
end;

procedure TSimpleThread.WaitThreadStop;
begin
  // ȴ߳̽
  StopThread;
  Terminate;
  SelfStart;
  WaitFor;
end;

end.
