unit uWorkThread;

interface

uses
  uSimpleThread;

type

  TWorkThread = class;

  TWorkStatus = (wsNeedANum, wsCountOver, wsStop);
  TOnWorkStatus = procedure(Sender: TWorkThread; AStatus: TWorkStatus) of object;

  TWorkThread = class(TSimpleThread)
  private
    procedure Work;
    procedure DoWork;
    procedure DoOnWorkStatus(AStatus: TWorkStatus);
    procedure Count;
  public
    procedure StartThread; override;
  public
    Num, Sum: integer;
    OnWorkStatus: TOnWorkStatus;
  end;

implementation

uses
  SysUtils;

procedure TWorkThread.Work;
begin
  ExeProcInThread(DoWork);
end;

procedure TWorkThread.DoWork;
begin

  if WaitStop then
  begin
    DoOnStatusMsg('ֹ߳ͣ!');
    DoOnWorkStatus(wsCountOver);
    exit;
  end;

  Num := 0;
  DoOnWorkStatus(wsNeedANum);
  if Num > 0 then
  begin
    Count;
    DoOnStatusMsg('Sum:' + IntToStr(Sum));
    DoOnWorkStatus(wsCountOver);
  end
  else
    SleepExceptStopped(100);

  Work; // ظ DoWork,ҲǱ̡
end;

procedure TWorkThread.Count;
var
  i: integer;
begin
  Sum := 0;
  for i := 1 to Num do
  begin
    Sum := Sum + i;
    sleep(5); //ʾãһÿЧ塣
  end;
end;

procedure TWorkThread.DoOnWorkStatus(AStatus: TWorkStatus);
begin
  if Assigned(OnWorkStatus) then
    OnWorkStatus(self, AStatus);
end;

procedure TWorkThread.StartThread;
begin
  inherited;
  Work;
end;

end.
